package com.massa.mrules.demos.insurance;

import com.massa.mrules.context.execute.MExecutionContext;
import com.massa.mrules.demos.insurance.model.Customer;
import com.massa.mrules.demos.insurance.model.Contract;
import com.massa.mrules.demos.insurance.model.Parameters;
import com.massa.mrules.demos.insurance.model.RulesetBean;
import com.massa.mrules.demos.insurance.model.Price;
import com.massa.mrules.exception.MConfigurationException;
import com.massa.mrules.exception.MExecutionException;
import com.massa.mrules.set.IMRuleExecutionSet;

import lombok.AllArgsConstructor;

/**
 * Rule engin execution service.
 */
@AllArgsConstructor
public class RulesetService {
	
	private final IMRuleExecutionSet ruleSet;
	
	public Price execute(Parameters parameters, Customer customer, Contract contract) throws MExecutionException, MConfigurationException {
		RulesetBean data = new RulesetBean();
		data.setParameters(parameters);
		data.setCustomer(customer);
		data.setContract(contract);

		@SuppressWarnings("unchecked")
		MExecutionContext<RulesetBean> ctxt = (MExecutionContext<RulesetBean>) ruleSet.getContextFactory().getExecutionContext();
		ctxt.setInput(data);
		ctxt.execute();

		return data.getPrice();
	}
}
