package com.massa.mrules.extensions.dsl.editor.web;

import org.springframework.beans.BeansException;
import org.springframework.beans.factory.config.BeanPostProcessor;
import org.springframework.stereotype.Component;

/**
 * This Spring post processor dynamically replaces MRulesDslEditorUI instance discovered by Vaadin
 * by a new instance of ExtMRulesDslEditorUI, allowing to add features to the UI.
 */
@Component
public class ReplaceOriginalUI implements BeanPostProcessor {

	@Override
	public Object postProcessBeforeInitialization(Object bean, String beanName) throws BeansException {
		return bean;
	}

	@Override
	public Object postProcessAfterInitialization(Object bean, String beanName) throws BeansException {
		if (bean.getClass().equals(MRulesDslEditorUI.class)) {
			return new ExtMRulesDslEditorUI();
		}
		return bean;
	}

}
